freedombone-app-turtl 25KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # turtl app
  12. #
  13. # http://portallinux.es/instalacion-servidor-turtl-debian-8
  14. # http://framacloud.org/cultiver-son-jardin/installation-de-turtl/
  15. #
  16. # License
  17. # =======
  18. #
  19. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  20. #
  21. # This program is free software: you can redistribute it and/or modify
  22. # it under the terms of the GNU Affero General Public License as published by
  23. # the Free Software Foundation, either version 3 of the License, or
  24. # (at your option) any later version.
  25. #
  26. # This program is distributed in the hope that it will be useful,
  27. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  28. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  29. # GNU Affero General Public License for more details.
  30. #
  31. # You should have received a copy of the GNU Affero General Public License
  32. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  33. VARIANTS="full full-vim writer"
  34. IN_DEFAULT_INSTALL=0
  35. SHOW_ON_ABOUT=1
  36. TURTL_DOMAIN_NAME=
  37. TURTL_CODE=
  38. TURTL_ONION_PORT=8107
  39. TURTL_PORT=8181
  40. TURTL_REPO="https://github.com/turtl/api.git"
  41. TURTL_COMMIT='53e00a5583f52de8f86ef380fe11c176b5738dcf'
  42. TURTL_ADMIN_PASSWORD=
  43. TURTL_STORAGE_LIMIT_MB=100
  44. TURTL_BASE_DIR=/etc/turtl
  45. # part of a hack to enable/disable signups
  46. TURTL_SIGNUP_STRING='Signup a new user'
  47. turtl_users_file=$TURTL_BASE_DIR/api/controllers/users.lisp
  48. turtl_variables=(ONION_ONLY
  49. DEFAULT_DOMAIN_NAME
  50. TURTL_DOMAIN_NAME
  51. TURTL_CODE
  52. TURTL_STORAGE_LIMIT_MB
  53. DDNS_PROVIDER
  54. MY_EMAIL_ADDRESS
  55. MY_USERNAME)
  56. function logging_on_turtl {
  57. echo -n ''
  58. }
  59. function logging_off_turtl {
  60. echo -n ''
  61. }
  62. function change_password_turtl {
  63. change_username="$1"
  64. new_user_password="$2"
  65. }
  66. function remove_user_turtl {
  67. remove_username="$1"
  68. }
  69. function add_user_turtl {
  70. new_username="$1"
  71. new_user_password="$2"
  72. echo '0'
  73. }
  74. function install_interactive_turtl {
  75. if [ ! $ONION_ONLY ]; then
  76. ONION_ONLY='no'
  77. fi
  78. if [[ $ONION_ONLY != "no" ]]; then
  79. TURTL_DOMAIN_NAME='notes.local'
  80. write_config_param "TURTL_DOMAIN_NAME" "$TURTL_DOMAIN_NAME"
  81. else
  82. function_check interactive_site_details
  83. interactive_site_details "turtl" "TURTL_DOMAIN_NAME" "TURTL_CODE"
  84. fi
  85. APP_INSTALLED=1
  86. }
  87. function turtl_disable_registrations {
  88. if grep -q "$TURTL_SIGNUP_STRING" $turtl_users_file; then
  89. if [ -f $turtl_users_file ]; then
  90. cp $turtl_users_file $TURTL_BASE_DIR/.users.lisp
  91. sed -i '/(route (:post "\/users") (req res)/,/(send-json res user))))/{//!d}' $turtl_users_file
  92. sed -i 's|(send-json res user))))|())|g' $turtl_users_file
  93. chown -R turtl:turtl $TURTL_BASE_DIR
  94. systemctl restart turtl
  95. fi
  96. fi
  97. }
  98. function turtl_enable_registrations {
  99. if ! grep -q "$TURTL_SIGNUP_STRING" $turtl_users_file; then
  100. if [ -f $TURTL_BASE_DIR/.users.lisp ]; then
  101. cp $TURTL_BASE_DIR/.users.lisp $turtl_users_file
  102. rm $TURTL_BASE_DIR/.users.lisp
  103. chown -R turtl:turtl $TURTL_BASE_DIR
  104. systemctl restart turtl
  105. fi
  106. fi
  107. }
  108. function configure_interactive_turtl_signups {
  109. # This implements a hack which removes or adds the function needed
  110. # to sign up new users. It should eventually be removed once that
  111. # capability exists within the api
  112. dialog --title $"Allow new turtl signups" \
  113. --backtitle $"Freedombone Control Panel" \
  114. --defaultno \
  115. --yesno $"\nAllow registration of new users?" 10 60
  116. sel=$?
  117. case $sel in
  118. 0)
  119. turtl_enable_registrations
  120. dialog --title $"Allow new turtl signups" \
  121. --msgbox $"New turtl user registrations are now allowed" 6 60
  122. return;;
  123. 1)
  124. turtl_disable_registrations
  125. dialog --title $"Disable new turtl signups" \
  126. --msgbox $"New turtl user registrations are now disabled" 6 60
  127. return;;
  128. 255) return;;
  129. esac
  130. }
  131. function configure_interactive_turtl_storage {
  132. data=$(tempfile 2>/dev/null)
  133. trap "rm -f $data" 0 1 2 5 15
  134. dialog --title $"Change storage limit" \
  135. --backtitle $"Freedombone Control Panel" \
  136. --inputbox $"Enter a storage limit in megabytes." 8 75 "$TURTL_STORAGE_LIMIT_MB" 2>$data
  137. sel=$?
  138. case $sel in
  139. 0)
  140. STORAGE=$(<$data)
  141. if [ ${#STORAGE} -gt 0 ]; then
  142. TURTL_STORAGE_LIMIT_MB=$STORAGE
  143. sed -i "s|defparameter *default-storage-limit*.*|defparameter *default-storage-limit* ${TURTL_STORAGE_LIMIT_MB})|g" $TURTL_BASE_DIR/api/config/config.lisp
  144. systemctl restart turtl
  145. dialog --title $"Change storage limit" \
  146. --msgbox $"Storage limit changed to ${TURTL_STORAGE_LIMIT_MB}M" 6 50
  147. fi
  148. ;;
  149. esac
  150. }
  151. function configure_interactive_turtl {
  152. data=$(tempfile 2>/dev/null)
  153. trap "rm -f $data" 0 1 2 5 15
  154. dialog --backtitle $"Freedombone Control Panel" \
  155. --title $"turtl app settings" \
  156. --radiolist $"Choose an operation:" 12 70 3 \
  157. 1 $"Enable/disable new user registrations" off \
  158. 2 $"Change storage limit" off \
  159. 3 $"Exit" on 2> $data
  160. sel=$?
  161. case $sel in
  162. 1) exit 1;;
  163. 255) exit 1;;
  164. esac
  165. case $(cat $data) in
  166. 1) configure_interactive_turtl_signups;;
  167. 2) configure_interactive_turtl_storage;;
  168. 3) return;;
  169. esac
  170. }
  171. function reconfigure_turtl {
  172. if [ -d $TURTL_BASE_DIR/data ]; then
  173. rm -rf $TURTL_BASE_DIR/data/*
  174. fi
  175. }
  176. function upgrade_turtl {
  177. CURR_TURTL_COMMIT=$(get_completion_param "turtl commit")
  178. if [[ "$CURR_TURTL_COMMIT" == "$TURTL_COMMIT" ]]; then
  179. return
  180. fi
  181. read_config_param "TURTL_DOMAIN_NAME"
  182. function_check set_repo_commit
  183. set_repo_commit $TURTL_BASE_DIR/api "turtl commit" "$TURTL_COMMIT" $TURTL_REPO
  184. # this is used as a crude way of disabling signups and so
  185. # should be superceded in future
  186. if [ -f $TURTL_BASE_DIR/.users.lisp ]; then
  187. turtl_disable_registrations
  188. fi
  189. systemctl restart turtl
  190. nginx_dissite $TURTL_DOMAIN_NAME
  191. chown -R turtl:turtl $TURTL_BASE_DIR
  192. nginx_ensite $TURTL_DOMAIN_NAME
  193. }
  194. function backup_local_turtl {
  195. read_config_param "TURTL_DOMAIN_NAME"
  196. source_directory=$TURTL_BASE_DIR
  197. if [ -d $source_directory ]; then
  198. dest_directory=turtl
  199. function_check suspend_site
  200. suspend_site ${TURTL_DOMAIN_NAME}
  201. function_check backup_directory_to_usb
  202. backup_directory_to_usb $source_directory $dest_directory
  203. function_check restart_site
  204. restart_site
  205. fi
  206. source_directory=/var/lib/rethinkdb
  207. if [ -d $source_directory ]; then
  208. dest_directory=rethinkdb
  209. function_check suspend_site
  210. suspend_site ${TURTL_DOMAIN_NAME}
  211. function_check backup_directory_to_usb
  212. backup_directory_to_usb $source_directory $dest_directory
  213. function_check restart_site
  214. restart_site
  215. fi
  216. }
  217. function restore_local_turtl {
  218. read_config_param "TURTL_DOMAIN_NAME"
  219. if [ $TURTL_DOMAIN_NAME ]; then
  220. temp_restore_dir=/root/tempturtl
  221. restore_directory_from_usb $temp_restore_dir turtl
  222. if [ -d ${temp_restore_dir}/etc/turtl ]; then
  223. cp -r ${temp_restore_dir}/etc/turtl/* /etc/turtl/
  224. else
  225. cp -r ${temp_restore_dir}/* /etc/turtl/
  226. fi
  227. if [ ! "$?" = "0" ]; then
  228. set_user_permissions
  229. backup_unmount_drive
  230. exit 36723
  231. fi
  232. rm -rf ${temp_restore_dir}
  233. chown -R turtl:turtl $TURTL_BASE_DIR
  234. temp_restore_dir=/root/temprethinkdb
  235. restore_directory_from_usb $temp_restore_dir rethinkdb
  236. if [ -d ${temp_restore_dir}/var/lib/rethinkdb ]; then
  237. cp -r ${temp_restore_dir}/var/lib/rethinkdb/* /var/lib/rethinkdb/
  238. else
  239. cp -r ${temp_restore_dir}/* /var/lib/rethinkdb/
  240. fi
  241. if [ ! "$?" = "0" ]; then
  242. set_user_permissions
  243. backup_unmount_drive
  244. exit 378324
  245. fi
  246. rm -rf ${temp_restore_dir}
  247. fi
  248. }
  249. function backup_remote_turtl {
  250. read_config_param "TURTL_DOMAIN_NAME"
  251. if [ $TURTL_DOMAIN_NAME ]; then
  252. temp_backup_dir=$TURTL_BASE_DIR
  253. if [ -d $temp_backup_dir ]; then
  254. echo $"Backing up turtl"
  255. backup_directory_to_friend $temp_backup_dir turtl
  256. echo $"Backup of turtl complete"
  257. else
  258. echo $"turtl domain specified but not found in $temp_backup_dir"
  259. exit 68725
  260. fi
  261. temp_backup_dir=/var/lib/rethinkdb
  262. if [ -d $temp_backup_dir ]; then
  263. echo $"Backing up rethinkdb"
  264. backup_directory_to_friend $temp_backup_dir rethinkdb
  265. echo $"Backup of rethinkdb complete"
  266. fi
  267. fi
  268. }
  269. function restore_remote_turtl {
  270. read_config_param "TURTL_DOMAIN_NAME"
  271. if [ $TURTL_DOMAIN_NAME ]; then
  272. temp_restore_dir=/root/tempturtl
  273. mkdir $temp_restore_dir
  274. function_check restore_directory_from_friend
  275. restore_directory_from_friend $temp_restore_dir turtl
  276. if [ -d ${temp_restore_dir}/etc/turtl ]; then
  277. cp -r ${temp_restore_dir}/etc/turtl/* /etc/turtl/
  278. else
  279. cp -r ${temp_restore_dir}/* /etc/turtl/
  280. fi
  281. if [ ! "$?" = "0" ]; then
  282. if [ -d /etc/turtl_previous ]; then
  283. mv /etc/turtl_previous $TURTL_BASE_DIR
  284. fi
  285. set_user_permissions
  286. exit 37823
  287. fi
  288. rm -rf ${temp_restore_dir}
  289. temp_restore_dir=/root/temprethinkdb
  290. mkdir $temp_restore_dir
  291. function_check restore_directory_from_friend
  292. restore_directory_from_friend $temp_restore_dir rethinkdb
  293. if [ -d ${temp_restore_dir}/var/lib/rethinkdb ]; then
  294. cp -r ${temp_restore_dir}/var/lib/rethinkdb/* /var/lib/rethinkdb/
  295. else
  296. cp -r ${temp_restore_dir}/* /var/lib/rethinkdb/
  297. fi
  298. if [ ! "$?" = "0" ]; then
  299. set_user_permissions
  300. exit 26783
  301. fi
  302. rm -rf ${temp_restore_dir}
  303. fi
  304. }
  305. function remove_turtl {
  306. if [ ! -d $TURTL_BASE_DIR ]; then
  307. return
  308. fi
  309. systemctl stop turtl
  310. systemctl disable turtl
  311. rm /etc/systemd/system/turtl.service
  312. systemctl daemon-reload
  313. remove_rethinkdb
  314. remove_app turtl
  315. remove_completion_param install_turtl
  316. sed -i '/turtl/d' $COMPLETION_FILE
  317. nginx_dissite $TURTL_DOMAIN_NAME
  318. if [ -f /etc/nginx/sites-available/$TURTL_DOMAIN_NAME ]; then
  319. rm /etc/nginx/sites-available/$TURTL_DOMAIN_NAME
  320. fi
  321. remove_certs $TURTL_DOMAIN_NAME
  322. function_check remove_onion_service
  323. remove_onion_service turtl ${TURTL_ONION_PORT}
  324. function_check remove_ddns_domain
  325. remove_ddns_domain $TURTL_DOMAIN_NAME
  326. rm -rf /etc/rethinkdb
  327. rm -rf /var/lib/rethinkdb
  328. rm -rf $TURTL_BASE_DIR
  329. groupdel -f turtl
  330. userdel -r turtl
  331. }
  332. function turtl_setup {
  333. PIDFILE=${PIDFILE:-nil}
  334. BINDADDR=${BINDADDR:-0.0.0.0}
  335. BINDPORT=${BINDPORT:-8181}
  336. PROD_ERR_HANDLING=${PROD_ERR_HANDLING:-t}
  337. if [[ $ONION_ONLY == 'no' ]]; then
  338. FQDN=${FQDN:-$TURTL_DOMAIN_NAME}
  339. SITE_URL=${SITE_URL:-https://$TURTL_DOMAIN_NAME}
  340. else
  341. FQDN=${FQDN:-$TURTL_ONION_HOSTNAME}
  342. SITE_URL=${SITE_URL:-http://$TURTL_ONION_HOSTNAME}
  343. fi
  344. ADMIN_EMAIL=${ADMIN_EMAIL:-$MY_EMAIL_ADDRESS}
  345. EMAIL_FROM=${EMAIL_FROM:-noreply@$DEFAULT_DOMAIN_NAME}
  346. SMTP_USER=${SMTP_USER:-}
  347. SMTP_PASS=${SMTP_PASS:-}
  348. DISPLAY_ERRORS=${DISPLAY_ERRORS:-t}
  349. DEFAULT_STORAGE_LIMIT=${DEFAULT_STORAGE_LIMIT:-100}
  350. STORAGE_INVITE_CREDIT=${STORAGE_INVITE_CREDIT:-25}
  351. if [[ $ONION_ONLY == 'no' ]]; then
  352. LOCAL_UPLOAD_URL=${LOCAL_UPLOAD_URL:-https://$TURTL_DOMAIN_NAME}
  353. else
  354. LOCAL_UPLOAD_URL=${LOCAL_UPLOAD_URL:-http://$TURTL_ONION_HOSTNAME}
  355. fi
  356. LOCAL_UPLOAD_PATH=${LOCAL_UPLOAD_PATH:-"$TURTL_BASE_DIR/data"}
  357. AWS_S3_TOKEN=${AWS_S3_TOKEN:-(:token ''
  358. :secret ''
  359. :bucket ''
  360. :endpoint 'https://s3.amazonaws.com')}
  361. # generates the config-file
  362. cat << __ENDCONFIG__ > $TURTL_BASE_DIR/api/config/config.lisp
  363. (in-package :turtl)
  364. (defparameter *root* (asdf:system-relative-pathname :turtl #P""))
  365. (defparameter *pid-file* "${PIDFILE}")
  366. (defvar *server-bind* "${BINDADDR}")
  367. (defvar *server-port* ${BINDPORT})
  368. (defvar *db-name* "turtl")
  369. (defvar *db-host* "127.0.0.1")
  370. (defvar *db-port* 28015)
  371. (defvar *production-error-handling* ${PROD_ERR_HANDLING})
  372. (defvar *enable-hsts-header* nil)
  373. (defvar *site-url* "${SITE_URL}")
  374. (defvar *api-path* "")
  375. (defvar *admin-email* "${ADMIN_EMAIL}")
  376. (defvar *email-from* "${EMAIL_FROM}")
  377. (defvar *email-user* "${SMTP_USER}")
  378. (defvar *email-pass* "${SMTP_PASS}")
  379. (defvar *display-errors* ${DISPLAY_ERRORS})
  380. (defparameter *default-storage-limit* ${DEFAULT_STORAGE_LIMIT})
  381. (defparameter *storage-invite-credit* ${STORAGE_INVITE_CREDIT})
  382. (vom:config :turtl :info)
  383. (defvar *local-upload* "${LOCAL_UPLOAD_PATH}")
  384. (defvar *local-upload-url* "${LOCAL_UPLOAD_URL}")
  385. (defvar *amazon-s3* "${AWS_S3_TOKEN}")
  386. __ENDCONFIG__
  387. cat $TURTL_BASE_DIR/api/config/config.footer >> $TURTL_BASE_DIR/api/config/config.lisp
  388. # start the turtl server
  389. systemctl restart rethinkdb
  390. if [ ! -f $TURTL_BASE_DIR/quicklisp/setup.lisp ]; then
  391. echo $"$TURTL_BASE_DIR/quicklisp/setup.lisp was not found"
  392. exit 6238234
  393. fi
  394. echo '[Unit]' > /etc/systemd/system/turtl.service
  395. echo 'Description=Note taking service' >> /etc/systemd/system/turtl.service
  396. echo 'Documentation=http://turtl.it' >> /etc/systemd/system/turtl.service
  397. echo 'Requires=network.target' >> /etc/systemd/system/turtl.service
  398. echo 'Requires=rethinkdb.service' >> /etc/systemd/system/turtl.service
  399. echo 'After=network.target' >> /etc/systemd/system/turtl.service
  400. echo 'After=rethinkdb.service' >> /etc/systemd/system/turtl.service
  401. echo '' >> /etc/systemd/system/turtl.service
  402. echo '[Service]' >> /etc/systemd/system/turtl.service
  403. echo 'Type=simple' >> /etc/systemd/system/turtl.service
  404. echo 'User=turtl' >> /etc/systemd/system/turtl.service
  405. echo "WorkingDirectory=$TURTL_BASE_DIR/api/" >> /etc/systemd/system/turtl.service
  406. if [[ "$check_architecture" == *"64"* && "$check_architecture" != *"arm"* ]]; then
  407. echo "ExecStart=$TURTL_BASE_DIR/ccl/lx86cl64 -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  408. else
  409. if [[ "$check_architecture" != *"arm"* ]]; then
  410. echo "ExecStart=$TURTL_BASE_DIR/ccl/lx86cl -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  411. else
  412. echo "ExecStart=$TURTL_BASE_DIR/ccl/armcl -l $TURTL_BASE_DIR/quicklisp/setup.lisp -l launch.lisp" >> /etc/systemd/system/turtl.service
  413. fi
  414. fi
  415. echo '' >> /etc/systemd/system/turtl.service
  416. echo '[Install]' >> /etc/systemd/system/turtl.service
  417. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/turtl.service
  418. chmod +x /etc/systemd/system/turtl.service
  419. chown -R turtl:turtl $TURTL_BASE_DIR
  420. systemctl enable turtl
  421. systemctl daemon-reload
  422. systemctl start turtl
  423. }
  424. function install_turtl_api {
  425. # https://github.com/ArthurGarnier/turtl-docker
  426. apt-get -yq install wget libterm-readline-perl-perl gcc libuv1-dev
  427. if [ ! -d $TURTL_BASE_DIR ]; then
  428. mkdir -p $TURTL_BASE_DIR
  429. fi
  430. cd $TURTL_BASE_DIR
  431. mkdir cd $TURTL_BASE_DIR/data
  432. check_architecture=$(uname -a)
  433. # Install ccl
  434. if [[ "$check_architecture" != *"arm"* ]]; then
  435. wget -P $TURTL_BASE_DIR/ ftp://ftp.clozure.com/pub/release/1.11/ccl-1.11-linuxx86.tar.gz
  436. mkdir -p $TURTL_BASE_DIR/ccl
  437. tar xvzf $TURTL_BASE_DIR/ccl-1.11-linuxx86.tar.gz -C $TURTL_BASE_DIR/ccl --strip-components=1
  438. else
  439. wget -P $TURTL_BASE_DIR/ ftp://ftp.clozure.com/pub/release/1.11/ccl-1.11-linuxarm.tar.gz
  440. mkdir -p $TURTL_BASE_DIR/ccl
  441. tar xvzf $TURTL_BASE_DIR/ccl-1.11-linuxarm.tar.gz -C $TURTL_BASE_DIR/ccl --strip-components=1
  442. fi
  443. # install quicklisp
  444. cat << __ENDCONFIG__ > $TURTL_BASE_DIR/quicklisp_install
  445. (load (compile-file "asdf.lisp"))
  446. (load (compile-file "quicklisp.lisp"))
  447. (quicklisp-quickstart:install)
  448. (ql:system-apropos "vecto")
  449. (ql:quickload "alexandria")
  450. (ql:quickload "babel")
  451. (ql:quickload "blackbird")
  452. (ql:quickload "bordeaux-threads")
  453. (ql:quickload "cffi")
  454. (ql:quickload "chipz")
  455. (ql:quickload "chunga")
  456. (ql:quickload "cl-annot")
  457. (ql:quickload "cl-async")
  458. (ql:quickload "cl-async-future")
  459. (ql:quickload "cl-base64")
  460. (ql:quickload "cl-fad")
  461. (ql:quickload "cl-libuv")
  462. (ql:quickload "cl-mongo-id")
  463. (ql:quickload "cl-ppcre")
  464. (ql:quickload "cl-rethinkdb")
  465. (ql:quickload "cl-smtp")
  466. (ql:quickload "cl+ssl")
  467. (ql:quickload "cl-syntax")
  468. (ql:quickload "cl-utilities")
  469. (ql:quickload "cl-vectors")
  470. (ql:quickload "do-urlencode")
  471. (ql:quickload "drakma")
  472. (ql:quickload "drakma-async")
  473. (ql:quickload "event-glue")
  474. (ql:quickload "fast-http")
  475. (ql:quickload "fast-io")
  476. (ql:quickload "flexi-streams")
  477. (ql:quickload "ironclad")
  478. (ql:quickload "jonathan")
  479. (ql:quickload "local-time")
  480. (ql:quickload "md5")
  481. (ql:quickload "named-readtables")
  482. (ql:quickload "nibbles")
  483. (ql:quickload "proc-parse")
  484. (ql:quickload "puri")
  485. (ql:quickload "quri")
  486. (ql:quickload "salza2")
  487. (ql:quickload "secure-random")
  488. (ql:quickload "smart-buffer")
  489. (ql:quickload "split-sequence")
  490. (ql:quickload "static-vectors")
  491. (ql:quickload "trivial-backtrace")
  492. (ql:quickload "trivial-features")
  493. (ql:quickload "trivial-garbage")
  494. (ql:quickload "trivial-gray-streams")
  495. (ql:quickload "trivial-types")
  496. (ql:quickload "usocket")
  497. (ql:quickload "vecto")
  498. (ql:quickload "vom")
  499. (ql:quickload "wookie")
  500. (ql:quickload "xmls")
  501. (ql:quickload "xsubseq")
  502. (ql:quickload "yason")
  503. (ql:quickload "zpb-ttf")
  504. (ql:quickload "zpng")
  505. (ql:add-to-init-file)
  506. (ccl::quit)
  507. __ENDCONFIG__
  508. if [ ! -f asdf.lisp ]; then
  509. wget https://common-lisp.net/project/asdf/asdf.lisp
  510. fi
  511. if [ ! -f quicklisp.lisp ]; then
  512. wget https://beta.quicklisp.org/quicklisp.lisp
  513. fi
  514. if [ -d $TURTL_BASE_DIR ]; then
  515. chown -R turtl:turtl $TURTL_BASE_DIR
  516. fi
  517. adduser --disabled-login --home=$TURTL_BASE_DIR --gecos 'turtl' turtl
  518. if [ ! -d $TURTL_BASE_DIR ]; then
  519. echo $"$TURTL_BASE_DIR directory not created"
  520. exit 263493
  521. fi
  522. groupadd turtl
  523. chown -R turtl:turtl $TURTL_BASE_DIR
  524. if [[ "$check_architecture" != *"arm"* ]]; then
  525. if [[ "$check_architecture" == *"64"* ]]; then
  526. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/lx86cl64" - turtl
  527. else
  528. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/lx86cl" - turtl
  529. fi
  530. else
  531. su -c "cat $TURTL_BASE_DIR/quicklisp_install | $TURTL_BASE_DIR/ccl/larmcl" - turtl
  532. fi
  533. rm $TURTL_BASE_DIR/quicklisp_install
  534. install_rethinkdb
  535. echo "http-port=8091" > /etc/rethinkdb/instances.d/turtl.conf
  536. chown -R rethinkdb:rethinkdb /var/lib/rethinkdb
  537. # install turtl API
  538. cd $TURTL_BASE_DIR/
  539. if [ -d /repos/turtl ]; then
  540. mkdir $TURTL_BASE_DIR/api
  541. cp -r -p /repos/turtl/. $TURTL_BASE_DIR/api
  542. cd $TURTL_BASE_DIR/api
  543. git pull
  544. else
  545. git clone $TURTL_REPO $TURTL_BASE_DIR/api
  546. fi
  547. cd $TURTL_BASE_DIR/api
  548. git checkout $TURTL_COMMIT -b $TURTL_COMMIT
  549. set_completion_param "turtl commit" "$TURTL_COMMIT"
  550. cd $TURTL_BASE_DIR/quicklisp/local-projects
  551. git clone git://github.com/orthecreedence/cl-hash-util
  552. if [[ "$check_architecture" != *"arm"* ]]; then
  553. if [[ "$check_architecture" == *"64"* ]]; then
  554. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/lx86cl64 -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  555. else
  556. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/lx86cl -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  557. fi
  558. else
  559. su -c "cat '(ccl:quit)' | $TURTL_BASE_DIR/ccl/larmcl -l $TURTL_BASE_DIR/quicklisp/setup.lisp" - turtl
  560. fi
  561. # config
  562. echo '(defvar *enabled-cors-resources* "resource://turtl-at-lyonbros-dot-com"' > $TURTL_BASE_DIR/api/config/config.footer
  563. echo ' "When set, will enable CORS for resource:// origins if they match the given' >> $TURTL_BASE_DIR/api/config/config.footer
  564. echo ' string. Entries should be comma separated (this string is passed verbatim in' >> $TURTL_BASE_DIR/api/config/config.footer
  565. echo ' the Access-Control-Allow-Origin header).")' >> $TURTL_BASE_DIR/api/config/config.footer
  566. echo '(defparameter *public-actions*' >> $TURTL_BASE_DIR/api/config/config.footer
  567. echo " \`((:post . ,(concatenate 'string *api-path* \"/users\"))" >> $TURTL_BASE_DIR/api/config/config.footer
  568. echo " (:post . ,(concatenate 'string *api-path* \"/log/error\"))" >> $TURTL_BASE_DIR/api/config/config.footer
  569. echo ' (:post . "/cla/sign")' >> $TURTL_BASE_DIR/api/config/config.footer
  570. echo ' (:get . "/ping")' >> $TURTL_BASE_DIR/api/config/config.footer
  571. echo ' (:get . "/admin")' >> $TURTL_BASE_DIR/api/config/config.footer
  572. echo " (:get . ,(cl-ppcre:create-scanner (concatenate 'string *api-path* \"/invites/codes/([0-9a-f-]+)\"))))" >> $TURTL_BASE_DIR/api/config/config.footer
  573. echo " \"A list of public resources/actions that do not require authentication.\")" >> $TURTL_BASE_DIR/api/config/config.footer
  574. echo "(defvar *analytics* '(:enabled t" >> $TURTL_BASE_DIR/api/config/config.footer
  575. echo ' :db "analytics"))' >> $TURTL_BASE_DIR/api/config/config.footer
  576. cp $TURTL_BASE_DIR/asdf.lisp $TURTL_BASE_DIR/api
  577. echo '(load (compile-file "asdf.lisp"))' > $TURTL_BASE_DIR/api/launch.lisp
  578. echo "(pushnew \"./\" asdf:*central-registry* :test #'equal)" >> $TURTL_BASE_DIR/api/launch.lisp
  579. echo '(load "start")' >> $TURTL_BASE_DIR/api/launch.lisp
  580. TURTL_ONION_HOSTNAME=$(add_onion_service turtl 80 ${TURTL_ONION_PORT})
  581. turtl_setup
  582. }
  583. function install_turtl_nginx {
  584. turtl_nginx_site=/etc/nginx/sites-available/$TURTL_DOMAIN_NAME
  585. if [[ $ONION_ONLY == "no" ]]; then
  586. function_check nginx_http_redirect
  587. nginx_http_redirect $TURTL_DOMAIN_NAME
  588. echo 'server {' >> $turtl_nginx_site
  589. echo ' listen 443 ssl;' >> $turtl_nginx_site
  590. echo ' listen [::]:443 ssl;' >> $turtl_nginx_site
  591. echo " server_name ${TURTL_DOMAIN_NAME};" >> $turtl_nginx_site
  592. echo '' >> $turtl_nginx_site
  593. echo ' # Security' >> $turtl_nginx_site
  594. function_check nginx_ssl
  595. nginx_ssl $TURTL_DOMAIN_NAME
  596. function_check nginx_disable_sniffing
  597. nginx_disable_sniffing $TURTL_DOMAIN_NAME
  598. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $turtl_nginx_site
  599. echo '' >> $turtl_nginx_site
  600. echo ' # Logs' >> $turtl_nginx_site
  601. echo ' access_log /dev/null;' >> $turtl_nginx_site
  602. echo ' error_log /dev/null;' >> $turtl_nginx_site
  603. echo '' >> $turtl_nginx_site
  604. echo ' location / {' >> $turtl_nginx_site
  605. function_check nginx_limits
  606. nginx_limits $TURTL_DOMAIN_NAME '15m'
  607. echo " proxy_pass http://localhost:${TURTL_PORT}/;" >> $turtl_nginx_site
  608. echo ' proxy_set_header Host $host;' >> $turtl_nginx_site
  609. echo ' proxy_buffering off;' >> $turtl_nginx_site
  610. echo ' }' >> $turtl_nginx_site
  611. echo '}' >> $turtl_nginx_site
  612. else
  613. echo -n '' > $turtl_nginx_site
  614. fi
  615. echo 'server {' >> $turtl_nginx_site
  616. echo " listen 127.0.0.1:${TURTL_ONION_PORT};" >> $turtl_nginx_site
  617. echo " server_name ${TURTL_ONION_HOSTNAME};" >> $turtl_nginx_site
  618. echo '' >> $turtl_nginx_site
  619. function_check nginx_disable_sniffing
  620. nginx_disable_sniffing $TURTL_DOMAIN_NAME
  621. echo '' >> $turtl_nginx_site
  622. echo ' # Logs' >> $turtl_nginx_site
  623. echo ' access_log /dev/null;' >> $turtl_nginx_site
  624. echo ' error_log /dev/null;' >> $turtl_nginx_site
  625. echo '' >> $turtl_nginx_site
  626. echo ' location / {' >> $turtl_nginx_site
  627. function_check nginx_limits
  628. nginx_limits $TURTL_DOMAIN_NAME '15m'
  629. echo " proxy_pass http://localhost:${TURTL_PORT}/;" >> $turtl_nginx_site
  630. echo ' proxy_set_header Host $host;' >> $turtl_nginx_site
  631. echo ' proxy_buffering off;' >> $turtl_nginx_site
  632. echo ' }' >> $turtl_nginx_site
  633. echo '}' >> $turtl_nginx_site
  634. function_check add_ddns_domain
  635. add_ddns_domain $TURTL_DOMAIN_NAME
  636. set_completion_param "turtl domain" "$TURTL_DOMAIN_NAME"
  637. function_check create_site_certificate
  638. create_site_certificate $TURTL_DOMAIN_NAME 'yes'
  639. function_check nginx_ensite
  640. nginx_ensite $TURTL_DOMAIN_NAME
  641. systemctl restart nginx
  642. }
  643. function install_turtl {
  644. install_turtl_api
  645. install_turtl_nginx
  646. APP_INSTALLED=1
  647. }